"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var StringUtils_1=require("../utils/StringUtils"),ObjectUtils_1=require("../utils/ObjectUtils"),ArrayUtils_1=require("../utils/ArrayUtils"),HashMapObject_1=require("../model/HashMapObject"),HTTPManagerGetRequest_1=require("./httpmanager/HTTPManagerGetRequest"),HTTPManagerBaseRequest_1=require("./httpmanager/HTTPManagerBaseRequest"),HTTPManager=function(){function t(t){if(void 0===t&&(t=!0),this.asynchronous=!0,this.timeout=0,this.internetCheckLocations=["https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js","https://ajax.aspnetcdn.com/ajax/modernizr/modernizr-2.8.3.js","https://code.jquery.com/jquery-3.2.1.slim.min.js"],this._queues=[],"boolean"!=typeof t)throw new Error("asynchronous is not boolean");this.asynchronous=t}return t.prototype.createQueue=function(t){if(StringUtils_1.StringUtils.isEmpty(t))throw new Error("name must be a non empty string");for(var e=0,n=this._queues;e<n.length;e++){if(n[e].name===t)throw new Error("queue "+t+" already exists")}this._queues.push({name:t,isRunning:!1,pendingRequests:[]})},t.prototype.countQueues=function(){return this._queues.length},t.prototype.isQueueRunning=function(t){if(StringUtils_1.StringUtils.isEmpty(t))throw new Error("name must be a non empty string");for(var e=0,n=this._queues;e<n.length;e++){var r=n[e];if(r.name===t)return r.isRunning}throw new Error("queue "+t+" does not exist")},t.prototype.deleteQueue=function(t){if(StringUtils_1.StringUtils.isEmpty(t))throw new Error("name must be a non empty string");for(var e=0;e<this._queues.length;e++)if(this._queues[e].name===t){if(this._queues[e].isRunning)throw new Error("queue "+t+" is currently running");return void this._queues.splice(e,1)}throw new Error("queue "+t+" does not exist")},t.prototype.generateUrlQueryString=function(t){var e="",n=[],r=[];if(ObjectUtils_1.ObjectUtils.isObject(t)&&ObjectUtils_1.ObjectUtils.getKeys(t).length>0){if(t instanceof HashMapObject_1.HashMapObject)n=t.getKeys(),r=t.getValues();else{n=Object.getOwnPropertyNames(t);for(var i=0;i<n.length;i++)r.push(t[n[i]])}for(i=0;i<n.length;i++)e+="&"+encodeURIComponent(n[i])+"="+encodeURIComponent(r[i]);return e.substring(1,e.length)}throw new Error("keyValuePairs must be a HashMapObject or a non empty Object")},t.prototype.isInternetAvailable=function(t,e){var n=this;if("function"!=typeof t||"function"!=typeof e)throw new Error("params must be functions");if(this.internetCheckLocations.length<=0)throw new Error("no check locations specified");var r=function(i){if(i.length<=0)return e();var s=i.shift();if(!StringUtils_1.StringUtils.isUrl(s))throw new Error("invalid check url : "+s);n.urlExists(String(s+"?r="+StringUtils_1.StringUtils.generateRandom(15,15)),t,function(){return r(i)})};!1===navigator.onLine?e():r(this.internetCheckLocations.slice(0))},t.prototype.urlExists=function(t,e,n){if(!StringUtils_1.StringUtils.isString(t))throw new Error("url must be a string");if("function"!=typeof e||"function"!=typeof n)throw new Error("params must be functions");if(StringUtils_1.StringUtils.isUrl(t)){var r=new HTTPManagerGetRequest_1.HTTPManagerGetRequest(t);r.successCallback=function(){return e()},r.errorCallback=function(){return n()},this.execute(r)}else n()},t.prototype.getUrlHeaders=function(e,n,r){var i=this;if(!StringUtils_1.StringUtils.isString(e))throw new Error("url must be a string");if("function"!=typeof n||"function"!=typeof r)throw new Error("params must be functions");if(!StringUtils_1.StringUtils.isUrl(e))throw new Error("invalid url "+e);var s=new XMLHttpRequest;this.timeout>0&&(s.timeout=this.timeout),s.open("GET",e,this.asynchronous),s.onload=function(){return n(s.getAllResponseHeaders().split("\n"))},s.onerror=function(){return r(s.statusText,s.status)},s.ontimeout=function(){return r(i.timeout+t.ERROR_TIMEOUT,408)},s.send()},t.prototype.execute=function(e,n,r){var i=this;void 0===n&&(n=null),void 0===r&&(r=null);var s=this._generateValidRequestsList(e);if(null!==n&&!(n instanceof Function)||null!==r&&!(r instanceof Function))throw new Error("finishedCallback and progressCallback must be functions");for(var o=0,u=!1,a=[],l=function(t,e,i,l,g){void 0===i&&(i=!1),void 0===l&&(l=""),void 0===g&&(g=-1);var c=t.request;o++,a[t.index]={url:c.url,response:e,isError:i,errorMsg:l,errorCode:g},i?(u=!0,c.errorCallback(l,g)):c.successCallback(e),c.finallyCallback(),null!==r&&r(c.url,s.length),o>=s.length&&null!==n&&n(a,u)},g=function(){var e={index:f,request:s[f]};if(!StringUtils_1.StringUtils.isString(s[f].url)||StringUtils_1.StringUtils.isEmpty(s[f].url))throw new Error("url "+f+" must be a non empty string");var n=new XMLHttpRequest;(s[f].timeout>0||c.timeout>0)&&(n.timeout=s[f].timeout>0?s[f].timeout:c.timeout);var r=s[f]instanceof HTTPManagerGetRequest_1.HTTPManagerGetRequest?"GET":"POST";n.open(r,s[f].url,c.asynchronous),n.onload=function(){n.status>=200&&n.status<400?l(e,n.responseText):l(e,"",!0,n.statusText,n.status)},n.onerror=function(){l(e,"",!0,n.statusText,n.status)},n.ontimeout=function(){l(e,"",!0,i.timeout+t.ERROR_TIMEOUT,408)},n.send()},c=this,f=0;f<s.length;f++)g()},t.prototype._generateValidRequestsList=function(t){var e=[];if(ArrayUtils_1.ArrayUtils.isArray(t)){if(t.length<=0)throw new Error("No requests to execute");e=StringUtils_1.StringUtils.isString(t[0])?t.map(function(t){return new HTTPManagerGetRequest_1.HTTPManagerGetRequest(t)}):t}else if(StringUtils_1.StringUtils.isString(t)&&!StringUtils_1.StringUtils.isEmpty(t))e=[new HTTPManagerGetRequest_1.HTTPManagerGetRequest(t)];else{if(!(t instanceof HTTPManagerBaseRequest_1.HTTPManagerBaseRequest))throw new Error("Invalid requests value");e=[t]}return e},t.prototype.queue=function(t,e,n){void 0===n&&(n=null);var r=this._generateValidRequestsList(t);if(null!==n&&!(n instanceof Function))throw new Error("finishedCallback and progressCallback must be functions");for(var i=0,s=this._queues;i<s.length;i++){var o=s[i];if(o.name===e){for(var u=r.length-1;u>=0;u--)o.pendingRequests.unshift(r[u]);if(null!==n){var a=new HTTPManagerGetRequest_1.HTTPManagerGetRequest("FINISHED_REQUEST_CALLBACK");a.finallyCallback=n,o.pendingRequests.unshift(a)}return void(this.isQueueRunning(e)||this._startQueue(e))}}throw new Error("queue "+e+" does not exist")},t.prototype._startQueue=function(t){for(var e=this,n=function(t){if(t.pendingRequests.length<=0)t.isRunning=!1;else{if("FINISHED_REQUEST_CALLBACK"===t.pendingRequests[t.pendingRequests.length-1].url){var r=t.pendingRequests.pop();t.pendingRequests.length<=0&&(t.isRunning=!1),r.finallyCallback()}t.pendingRequests.length>0&&(t.isRunning=!0,e.execute(t.pendingRequests.pop(),function(){return n(t)}))}},r=0,i=this._queues;r<i.length;r++){var s=i[r];if(s.name===t)return void n(s)}},t.prototype.loadResourcesFromList=function(t,e,n,r,i){var s=this;if(void 0===i&&(i=null),!StringUtils_1.StringUtils.isString(t)||StringUtils_1.StringUtils.isEmpty(t))throw new Error("urlToResourcesList must be a non empty string");if(!StringUtils_1.StringUtils.isString(e)||StringUtils_1.StringUtils.isEmpty(e))throw new Error("basePath must be a non empty string");this.execute(t,function(o,u){if(o[0].isError)return r(t,o[0].errorMsg,o[0].errorCode);for(var a=[],l=e+("/"===e.charAt(e.length-1)?"":"/"),g=StringUtils_1.StringUtils.getLines(o[0].response),c=0,f=g;c<f.length;c++){var h=f[c];a.push(StringUtils_1.StringUtils.formatPath(l+h,"/"))}s.execute(a,function(t,e){for(var i=[],s=0,o=t;s<o.length;s++){var u=o[s];if(u.isError)return r(u.url,u.errorMsg,u.errorCode);i.push(u.response)}n(g,i)},i)})},t.ERROR_TIMEOUT=" ms Timeout reached",t}();exports.HTTPManager=HTTPManager;